searchNodes=[{"ref":"PermissionEx.html","title":"PermissionEx","type":"module","doc":"Main module and interface to testing permissions. If you wish to test a single permission for equality, then you would use PermissionEx.test_permission/2. If you wish to test an entire permission struct for matching allowed permissions then you would use PermissionEx.test_permissions/2. If you wish to test an entire permission struct for matching allowed permissions on a struct tagged map then you would use PermissionEx.test_tagged_permissions/2. The examples in this module use these definitions of structs for testing permissions: defmodule PermissionEx.Test.Structs.User do @moduledoc false @derive [Poison.Encoder] defstruct name: nil end defmodule PermissionEx.Test.Structs.Page do @moduledoc false @derive [Poison.Encoder] defstruct action: nil end defmodule PermissionEx.Test.Structs.PageReq do @moduledoc false @derive [Poison.Encoder] defstruct action: nil end defmodule PermissionEx.Test.Structs.PagePerm do @moduledoc false @derive [Poison.Encoder] defstruct action: nil end"},{"ref":"PermissionEx.html#test_permission/2","title":"PermissionEx.test_permission/2","type":"function","doc":"This tests a specific required permission against a specific permission. If either are :_ then it is true. If both are identical, then it is true. If the permission is the list starting with :any such as [:any | &lt;permissions&gt;] then each permission in the list is tested against the requirement The permission &quot;&quot; is equivilent to `:` Examples iex&gt; PermissionEx.test_permission(:_, :_) true iex&gt; PermissionEx.test_permission(:_, &quot;_&quot;) true iex&gt; PermissionEx.test_permission(&quot;_&quot;, :_) true iex&gt; PermissionEx.test_permission(&quot;_&quot;, &quot;_&quot;) true iex&gt; PermissionEx.test_permission(:_, nil) true iex&gt; PermissionEx.test_permission(nil, :_) true iex&gt; PermissionEx.test_permission(&quot;_&quot;, nil) true iex&gt; PermissionEx.test_permission(nil, &quot;_&quot;) true iex&gt; PermissionEx.test_permission(nil, nil) true iex&gt; PermissionEx.test_permission(nil, :notnil) false iex&gt; PermissionEx.test_permission(:notnil, nil) false iex&gt; PermissionEx.test_permission(1, 1) true iex&gt; PermissionEx.test_permission(1, 1.0) false iex&gt; PermissionEx.test_permission(&#39;test&#39;, &#39;test&#39;) true iex&gt; PermissionEx.test_permission(&quot;test&quot;, &quot;test&quot;) true iex&gt; PermissionEx.test_permission(&#39;test&#39;, &quot;test&quot;) false iex&gt; PermissionEx.test_permission(:show, :show) true iex&gt; PermissionEx.test_permission(:show, :edit) false iex&gt; PermissionEx.test_permission(:show, [:any]) false iex&gt; PermissionEx.test_permission(:show, [:any, :show]) true iex&gt; PermissionEx.test_permission(:show, [:any, :show, :edit]) true iex&gt; PermissionEx.test_permission(:show, [:any, :edit, :show]) true iex&gt; PermissionEx.test_permission(:show, [:any, :edit, :otherwise]) false iex&gt; PermissionEx.test_permission(:show, [&quot;any&quot;]) false iex&gt; PermissionEx.test_permission(:show, [&quot;any&quot;, :show]) true iex&gt; PermissionEx.test_permission(:show, [&quot;any&quot;, :show, :edit]) true iex&gt; PermissionEx.test_permission(:show, [&quot;any&quot;, :edit, :show]) true iex&gt; PermissionEx.test_permission(:show, [&quot;any&quot;, :edit, :otherwise]) false iex&gt; PermissionEx.test_permission(:show, [&quot;any&quot;, &quot;edit&quot;, &quot;show&quot;]) true iex&gt; PermissionEx.test_permission(:show, [&quot;any&quot;, &quot;edit&quot;, &quot;otherwise&quot;]) false iex&gt; PermissionEx.test_permission(:show, [:many]) false iex&gt; PermissionEx.test_permission(:show, [:many, :show, :edit]) true iex&gt; PermissionEx.test_permission([:show, :edit], [:many, :show, :edit]) true iex&gt; PermissionEx.test_permission([:edit, :show], [:many, :show, :edit]) true iex&gt; PermissionEx.test_permission(:show, &quot;show&quot;) true iex&gt; PermissionEx.test_permission(:show, &quot;_&quot;) true iex&gt; PermissionEx.test_permission(nil, &quot;_&quot;) true iex&gt; PermissionEx.test_permission([:show, 123], [&quot;show&quot;, 123]) true iex&gt; PermissionEx.test_permission(%{}, %{}) true iex&gt; PermissionEx.test_permission(%{action: :show}, %{action: &quot;show&quot;}) true iex&gt; PermissionEx.test_permission(%{action: &quot;show&quot;}, %{action: &quot;show&quot;}) true iex&gt; PermissionEx.test_permission(%{action: :show}, %{&quot;action&quot; =&gt; :show}) true iex&gt; PermissionEx.test_permission(%{&quot;action&quot; =&gt; :show}, %{action: :show}) true iex&gt; PermissionEx.test_permission(%{action: :show}, %{action: [:any, :show, :index]}) true iex&gt; PermissionEx.test_permission(%{action: :none}, %{action: [:any, :show, :index]}) false"},{"ref":"PermissionEx.html#test_permissions/2","title":"PermissionEx.test_permissions/2","type":"function","doc":"This tests a specific requirement against a set of permission. See PermissionEx.test_permission/2 for possible permission formats. Examples iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, :_) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, true) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, false) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, nil) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, []) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{}) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: :edit}) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: :show}) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: :_}) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: true}) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: [:any, :edit, :show]}) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{}) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{action: :edit}) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{action: :show}) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{action: :_}) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{action: true}) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{action: [:any, :edit, :show]}) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [:_]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [true]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [false]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [nil]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [[]]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{}]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{action: :edit}]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{action: :show}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{action: :_}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{action: true}]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{action: [:any, :edit, :show]}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{}]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{action: :edit}]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{action: :show}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{action: :_}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{action: true}]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{action: [:any, :edit, :show]}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{&quot;action&quot; =&gt; :edit}]) false iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{&quot;action&quot; =&gt; :show}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{&quot;action&quot; =&gt; :_}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{&quot;action&quot; =&gt; &quot;_&quot;}]) true iex&gt; PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: [:something, 123]}, [%{&quot;action&quot; =&gt; [&quot;something&quot;, 123]}]) true"},{"ref":"PermissionEx.html#test_tagged_permissions/2","title":"PermissionEx.test_tagged_permissions/2","type":"function","doc":"This takes a map of permissions with the keys being a tag to be looked up on. The required permission struct type is the tag to match on. In the key of :admin, if true, will always return true no matter what the required matcher wants, it is an override that allows all permissions. If the key of :admin contains a map, then the tag will be looked up in it and tested against, such as if true then they will get permission for that tag regardless. If a given tag has the boolean of &#39;true&#39; then it will always return true, basically giving admin just for that specific tag. See PermissionEx.test_permissions/2 for how a permission struct/map is matched. See PermissionEx.test_permission/2 for possible permission formats. Examples iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{}, %{admin: true}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; true}}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.User{}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; true}}) false iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; %{action: :show}}}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :edit}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; %{action: :show}}}) false iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; true}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %{}}) false iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %{}}) false iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %PermissionEx.Test.Structs.Page{action: :show}}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %PermissionEx.Test.Structs.Page{action: :_}}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %PermissionEx.Test.Structs.Page{action: nil}}) false iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; [%PermissionEx.Test.Structs.Page{action: :show}]}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; [%PermissionEx.Test.Structs.Page{action: :_}]}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; [%PermissionEx.Test.Structs.Page{action: nil}]}) false iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{PermissionEx.Test.Structs.PageReq =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{PermissionEx.Test.Structs.PagePerm =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) false iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{&quot;Elixir.PermissionEx.Test.Structs.PageReq&quot; =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{&quot;Elixir.PermissionEx.Test.Structs.PagePerm&quot; =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) false"},{"ref":"PermissionEx.html#t:permission/0","title":"PermissionEx.permission/0","type":"type","doc":"A Permission matcher is either anything, of which it must then match the required permission precisely, or it is a list starting with :any such as [:any | permissions] where each item in the list will be tested against the requirement as a base permission, if any are true then this matches."},{"ref":"PermissionEx.html#t:permissions/0","title":"PermissionEx.permissions/0","type":"type","doc":"This is a set of permissions such as %{}, [%{}], etc... A :_ or true matches any entire requirement set. A false or nil will always not match. A list of permissions will each be checked individually against the requirement, if any are a true match then it returns true. A struct or map will be tested against the requirements directly, a struct is treated like a map except the :__struct__ field will not be tested, useful if you want a requirement and permission to use different structs. Do note that the tagged_permissions keys should match the :__struct__ of the requirement struct, not of the permission struct. I.E. given a PermissionEx.Test.Structs.PageReq and a PermissionEx.Test.Structs.PagePerm, such as if you want the default values for the requirement stuct to be by default tight or lenient, and the opposite for the permission struct, then calling PermissionEx.test_permissions/2 will be like: iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{PermissionEx.Test.Structs.PageReq =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) true iex&gt; PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{PermissionEx.Test.Structs.PagePerm =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) false"},{"ref":"PermissionEx.html#t:tagged_permissions/0","title":"PermissionEx.tagged_permissions/0","type":"type","doc":"This is a map that has a mapping of a %{Struct =&gt; %Struct{}}. The value being an actual struct is optional, it can also be a map on its own, as long as it has matching keys =&gt; values of the struct, any missing will have the requirement be false unless the requirement is :_. If there is an :admin key in the permissions, then this is checked first and can act as an easy override for the main permission set."},{"ref":"readme.html","title":"PermissionEx","type":"extras","doc":"PermissionEx A simple Struct-based Permission system for Elixir. Created to be used with Phoenix but has no requirement or any real integration with it as this is designed to be entirely generic."},{"ref":"readme.html#installation","title":"PermissionEx - Installation","type":"extras","doc":"Available on Hex, the package can be installed by adding permission_ex to the list of dependencies in mix.exs: def deps do [{:permission_ex, &quot;~&gt; 0.6.0&quot;}] end"},{"ref":"readme.html#features","title":"PermissionEx - Features","type":"extras","doc":"This is the current feature set of what is done, planned, and thought about. If any feature is not done yet or if any feature wants to be added that is not on this list then please open an issue and/or pull request to have it get done faster. [x] Permission Matcher to test permissions against a requirement. [x] Admin Permission Matcher to pre-authorize before testing normal permissions. [ ] This currently works well with the canada library, but is there anything that can be done to make it even more simple? [ ] Maybe add some more Permission specialties, such as maybe a {:range, lower, upper} test, maybe a function call test? [ ] Maybe add helpers for serializing the structs to/from json by using Poison. [ ] Maybe add helpers to serialize the structs in other ways? If so then into what ways? [ ] Maybe a deny Permission Matcher to hard deny before admin is tested. [ ] Maybe add support to take a list of requirements and test each so all must have a match. [ ] Maybe Create plugs to test permissions and either set a variable or kill/redirect the plug chain."},{"ref":"readme.html#usage","title":"PermissionEx - Usage","type":"extras","doc":"General usage will usually be something like reading either a tagged map or a specific permission set from, say, a database or elsewhere, then comparing it to a specific requirement. For example, say you have this phoenix controller method: def show(conn, _params) do conn |&gt; render(&quot;index.html&quot;) end And if you have a permission set from the logged in user (or you can pre-fill an anonymous user permission set, or leave empty if anon should have no access to anything), say you have it on conn.assigns.perms and it is a tagged map, then you could test it like this: def show(conn, _params) do if PermissionEx.test_tagged_permissions(MyApp.Perms.IndexPage{action: :show}, conn.assigns.perms) do conn |&gt; render(&quot;index.html&quot;) else conn |&gt; render(&quot;unauthorized.html&quot;) end end"},{"ref":"readme.html#examples","title":"PermissionEx - Examples","type":"extras","doc":"Please see PermissionEx for detailed examples. All of the examples use these as the example structs: defmodule PermissionEx.Test.Structs.User do @moduledoc false @derive [Poison.Encoder] defstruct name: nil end defmodule PermissionEx.Test.Structs.Page do @moduledoc false @derive [Poison.Encoder] defstruct action: nil end defmodule PermissionEx.Test.Structs.PageReq do @moduledoc false @derive [Poison.Encoder] defstruct action: nil end defmodule PermissionEx.Test.Structs.PagePerm do @moduledoc false @derive [Poison.Encoder] defstruct action: nil end Testing a specific permission: PermissionEx.test_permission/2 The required permission is the first argument, the allowed permission is on the right. Normal usage would be something like: permissions = [:show, :edit] # From somewhere else PermissionEx.test_permission(:show, permissions) # =&gt; true PermissionEx.test_permission(:admin, permissions) # =&gt; true Identical things match: PermissionEx.test_permission(:anything_identical, :anything_identical) # =&gt; true PermissionEx.test_permission(&quot;anything identical&quot;, &quot;anything identical&quot;) # =&gt; true Anything matches the atom :_: PermissionEx.test_permission(:_, :_) # =&gt; true PermissionEx.test_permission(:_, :anything) # =&gt; true PermissionEx.test_permission(:anything, :_) # =&gt; true If the permission is a [:any | permissions] then each permission in the list will be tested individually for if they match the requirement, and if any test true then this will be true: PermissionEx.test_permission(:show, [:any]) # =&gt; false PermissionEx.test_permission(:show, [:any, :show]) # =&gt; true PermissionEx.test_permission(:show, [:any, :show, :edit]) # =&gt; true PermissionEx.test_permission(:show, [:any, :edit, :show]) # =&gt; true PermissionEx.test_permission(:show, [:any, :edit, :otherwise]) # =&gt; false If an atom and binary fail to match, they will be tested again with the required atom being to_string&#39;d, good for if loading from JSON or so, such as in: PermissionEx.test_permission(:show, [&quot;any&quot;, :edit, :show]) # =&gt; true PermissionEx.test_permission(:show, [&quot;any&quot;, &quot;edit&quot;, &quot;show&quot;]) # =&gt; true PermissionEx.test_permission(:show, &quot;show&quot;) # =&gt; true Testing a permission set against a requirement struct: PermissionEx.test_permissions/2 You can test a struct requirement against a permission map or list or maps or even against override values such as in: Via an override, where true or :_ allows the entire requirement, and where false, nil, an empty list [], or an empty map or struct %{} return false: PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, :_) # =&gt; true PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, true) # =&gt; true PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, false) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, nil) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, []) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{}) # =&gt; false Or via a map or struct, structs tend to be better if the default values for the struct align with the needs better, if anything in a map is missing that a requirement tests for then it will return false: PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: :_}) # =&gt; true PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: true}) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{action: [:any, :edit, :show]}) # =&gt; true PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{}) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{action: :edit}) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %PermissionEx.Test.Structs.Page{action: :show}) # =&gt; true Or a list of any of the above, any overrides, maps, or structs: PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [true]) # =&gt; true PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [false]) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{action: :edit}]) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%{action: :show}]) # =&gt; true PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{action: :edit}]) # =&gt; false PermissionEx.test_permissions(%PermissionEx.Test.Structs.Page{action: :show}, [%PermissionEx.Test.Structs.Page{action: :show}]) # =&gt; true Testing a tagged permission set against a requirement struct: PermissionEx.test_tagged_permissions/2 You can test a struct requirement against a map of permissions keyed on the requirement structs :__struct__ value. There is also an override key of :admin, this is another tagged permission map or an override that is tested before the main permissions are tested. The permission map is just a map of the permission sets, so for example: PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %{}}) # =&gt; false PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %PermissionEx.Test.Structs.Page{action: :show}}) # =&gt;true PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %PermissionEx.Test.Structs.Page{action: :_}}) # =&gt; true PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{PermissionEx.Test.Structs.Page =&gt; %PermissionEx.Test.Structs.Page{action: nil}}) # =&gt; false Do note, the permission map is keyed on the requirement struct, not on the struct of its value, this allows you to define a different struct for the permission side that could have certain default values to be set to what you want, such as in: PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{PermissionEx.Test.Structs.PageReq =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) # =&gt; true PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.PageReq{action: :show}, %{PermissionEx.Test.Structs.PagePerm =&gt; [%PermissionEx.Test.Structs.PagePerm{action: :_}]}) # =&gt; false If there is an :admin key on the struct, then it is checked first, this allows you to set up easy overrides for all or specific matches: # Can override and allow absolutely everything by just setting admin: true PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{}, %{admin: true}) # =&gt; true # Or can set it on a specific struct, it will not affect others then: PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; true}}) # =&gt; true PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.User{}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; true}}) # =&gt; false # Can do fine-tuned matching as well if an override is needed, it will not allow non-matches PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :show}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; %{action: :show}}}) # =&gt; true PermissionEx.test_tagged_permissions(%PermissionEx.Test.Structs.Page{action: :edit}, %{admin: %{PermissionEx.Test.Structs.Page =&gt; %{action: :show}}}) # =&gt; false"}]